<?php
// PukiWiki - Yet another WikiWikiWeb clone.
// リダイレクトジャンプ プラグイン
// Copyright (C) 2009 teanan / PukiWiki Developers Team.
// License: GPL version 2
//
// ** 使い方
// + このファイルを jumpto.inc.php としてpluginフォルダに入れます。
// + skin/pukiwiki.skin.php の最初に次の2行を加えてください。
//	 require_once(PLUGIN_DIR . 'jumpto.inc.php');
//	 $body = plugin_jumpto_replace($body);
/*
// -------------------------------------------------------------------------------------------------
// * 隠居小屋改造版
//
// :本家サイト様|
//	 http://hirotea.daa.jp/pukiwiki/index.php?FrontPage
// :基となったプラグインの場所|
//	 http://hirotea.daa.jp/pukiwiki/index.php?%BC%AB%BA%EE%A5%D7%A5%E9%A5%B0%A5%A4%A5%F3%2Fjumpto.inc.php
//
// ** 使い方補足(本家サイト様よりほぼコピペ)
// + MenuBarでも置換が必要な場合、以下のように書き換え
//	-	 <div id="menubar"><?php echo do_plugin_convert('menu') ?></div>
//	+	 <div id="menubar"><?php echo plugin_jumpto_replace(do_plugin_convert('menu')) ?></div>
// + COPYRIGHT部分でも置換が必要な場合
//	- <?php echo S_COPYRIGHT ?>.
//	+ <?php echo plugin_jumpto_replace(S_COPYRIGHT) ?>.
//
// *** アイコンの表示
// + アイコンデータを image フォルダに格納します。
// + skin/pukiwiki.css.php の最後に次の行を加えてください。
//   画像ファイル名が違う場合は、「external_link.gif」部分を適宜変更してください。
//	 a.externalLink {
//	 	margin: 0 4px 0 0;
//	 	padding: 0 14px 0 0;
//	 	background: url(../image/external_link.gif) no-repeat right center;
//	 }
//
// ** 更新履歴
// *** 2017-08-24
// - 除外アドレスを設定出来るようにした
// - 説明文を一部変更した
// *** 2011-11-26
// - 同じサイト内ページへのリンクの一部や#contentsで作成したリンクが外部リンクと判定されるのを修正
// - 外部リンクを示す画像を、img要素での追加からclass名の追加(背景画像での表示)へと変更
// - クッションページを挟むかどうかの設定を追加((FALSEにした場合、プラグインの趣旨から外れます))
*/

// メッセージ表示時間
define('PLUGIN_JUMPTO_WAITTIME', 5);		// second
// exlinkアイコン付加
define('PLUGIN_JUMPTO_EXLINK', FALSE);
// クッションページを新しいウィンドウで開く
define('PLUGIN_JUMPTO_NEW_WINDOW', FALSE);
// --- add by 隠居小屋 start
// クッションページを挟む
define('PLUGIN_JUMPTO_PAGE', TRUE);
// リンクに付加するクラス名
define('CLASS_NAME', 'externalLink');
// 除外アドレス
define('EXCLUSION', serialize(array(
	// 除外したいアドレスを「,」区切りで記述してください
	// 除外アドレスで始まるリンクは、外部リンク判定を行いません
	// 例:
	//'https://www.google.co.jp/',
	//'https://www.yahoo.co.jp/',
)));
// --- add by 隠居小屋 end

function plugin_jumpto_action()
{
	global $vars;

	$url = isset($vars['r'])? $vars['r'] : '';
	if (is_url($url))
		plugin_jumpto_catbody($url);

	// Jump to FrontPage
	header('Location:' . get_script_uri());
}

// meta refresh のページを作成する
function plugin_jumpto_catbody($url)
{
	$waittime = PLUGIN_JUMPTO_WAITTIME;
	// edit by 隠居小屋
	//$s_url = htmlspecialchars($url);
	$s_url = htmlspecialchars($url, ENT_QUOTES, CONTENT_CHARSET);

	$charset = CONTENT_CHARSET;

	header('Content-Type: text/html; charset=' . $charset);
	echo <<<EOD
<html>
<head>
 <meta http-equiv="content-type" content="application/xhtml+xml; charset=$charset" />
 <meta http-equiv="Refresh" content="$waittime;URL=$url" />
</head>
<body>
<p>選択されたURLは本サイトのコンテンツではありません。</p>
<p>
 <div>$waittime 秒後に自動的にジャンプします。</div>
 <div>ジャンプしない場合は、下のURLを選択してください。</div>
 <p>
	<a href="$url">$s_url</a>
 </p>
</p>
</body>
</html>
EOD;
	exit;
}

// URL置換処理
function plugin_jumpto_replace($catbody)
{
	// edit by 隠居小屋 start
	/*
	$script = get_script_uri();
	$pattern = "#(<a[^>]+href\s*\=\s*)\"((?!$script)[^\"]+)\"([^>]*>)(.+?</a>)#i";

	return preg_replace_callback($pattern,
		'plugin_jumpto_replace_callback', $catbody);
	*/
	$script = get_script_uri();
	$className = CLASS_NAME;
	$charset = CONTENT_CHARSET;
	$document = new DOMDocument('1.0', $charset);
	$exclusion = unserialize(EXCLUSION);
	$html = mb_convert_encoding($catbody, 'HTML-ENTITIES', $charset);
	$document->loadHTML($html);
	$anchors = $document->getElementsByTagName('a');
	for ($i = 0; $i < $anchors->length; $i++) {
		$anchor = $anchors->item($i);
		$url = $anchor->getAttribute('href');
		if (is_url($url) && strpos($url, $script) !== 0) {
			// 除外アドレスの判定
			foreach ($exclusion as $e_url) {
				if (strpos($url, $e_url) === 0) {
					continue 2;
				}
			}
			// クッションページへのリンク付加
			if (PLUGIN_JUMPTO_PAGE) {
				$url = $script . '?cmd=jumpto&r=' . rawurlencode($url); // &はsetAttribute時に文字実体参照に置換される模様
				$anchor->setAttribute('href', $url);
			}
			// アイコン付加
			if (PLUGIN_JUMPTO_EXLINK) {
				if ($anchor->hasAttribute('class')) {
					$isClassName = '/\s' . $className . '\s/'; // 指定するクラス名の有無
					$oldClassName = $anchor->getAttribute('class');
					if (preg_match($isClassName, ' ' . $oldClassName . ' ') == 0) {
						$className = $oldClassName . ' ' . $className;
					} else {
						$className = $oldClassName;
					}
				}
				$anchor->setAttribute('class', $className);
			}
			// 別ウィンドウで開く
			if (PLUGIN_JUMPTO_NEW_WINDOW) {
				$anchor->setAttribute('target', '_blank');
			}
		}
	}
	$body = $document->getElementsByTagName('body')->item(0);
	$childNodes = $body->childNodes;
	$innerHtml = '';
	foreach ($childNodes as $child) {
		$innerHtml .= $child->ownerDocument->saveXML($child);
	}
	return $innerHtml;
	// edit by 隠居小屋 end
}

// delete by 隠居小屋 start
/*
// URL置換処理(callback)
function plugin_jumpto_replace_callback($matches)
{
	$script = get_script_uri();
	$exicon = '';
	if (is_url($matches[2])) {
		$url = $script . '?cmd=jumpto&amp;r=' . rawurlencode($matches[2]);
		if (PLUGIN_JUMPTO_EXLINK) {
			$exicon = <<<EOD
<img src="image/external_link.gif" height="11px" width="11px" alt="[外部リンク]" class="external_link" />
EOD;
		}
	} else {
		$url = $matches[2];
	}
	$params = $matches[3];
	if(PLUGIN_JUMPTO_NEW_WINDOW) {
		$params = ' target="_blank"' . $matches[3];
	}
	return $matches[1] . '"' . $url . '"' . $params . $matches[4] . $exicon;
}
*/
// delete by 隠居小屋 end
?>
